
#ifndef _extern_h_included
#define _extern_h_included


#ifndef _qnx_drvdecl_h_included
#include <qnx/drvdecl.h>
#endif

#ifndef  _qnx_drvmount_h_included
#include <qnx/drvmount.h>
#endif

#ifndef  _qnx_sys_dma_h_included
#include <qnx/sys/dma.h>
#endif

#ifndef  _qnx_sys_buf_h_included
#include <qnx/sys/buf.h>
#endif

#ifndef  _qnx_sys_block_h_included
#include <qnx/sys/block.h>
#endif

#ifndef  _qnx_sys_sdebug_h_included
#include <qnx/sys/sdebug.h>
#endif

#ifndef  _qnx_sys_endian_h_included
#include <qnx/sys/endian.h>
#endif

#ifndef  _qnx_sys_timeout_h_included
#include <qnx/sys/timeout.h>
#endif

#ifndef _qnx_sys_pos_h_included
#include <qnx/sys/pos.h>
#endif

#ifndef _ps2scsi_h_included
#include "ps2scsi.h"
#endif

#ifndef __OSINFO_H_INCLUDED
#include <sys/osinfo.h>
#endif

extern struct _osinfo _osdata;
extern struct    _sysmsg_version_reply    version_stamp;

extern char driver_name[_DNAME_PREFIX];
extern    char    *fsys_name;

INT_PROC int_handler();

SYNC_PROC ps2s_init();
SYNC_PROC ps2s_term();
ASYNC_PROC ps2s_open();
ASYNC_PROC ps2s_close();
ASYNC_PROC ps2s_io();

extern void (* (etable[_DRIVER_TBL_SIZE]))();

extern volatile  int    IoStatus;
extern volatile  int    DriverInit;
extern volatile  int    DriverState;
extern volatile    IntStatus;        /* bumped when interrupt transaction done */
extern unsigned    Function;        /* Function interrupt handler is doing    */
extern unsigned    NumBlocks;        /* Number of blocks yet to transfer        */
extern unsigned    DriveNo;    /* Disk number */
extern unsigned    Istate;        /* Interrupt Handler state (2-phase)    */
extern disk_t        *StatusPtr;        /* Blocks actually transfered so far    */
extern cbufp_t        CachePtr;
extern int    int_id;

/*
    These areas are for the binding between the filesystem and the driver,
    they are 'relative' constants, that is they can only be redefined at
    startup.

*/

extern    pid_t        NotifyPid;            /* Proxy for int handler to use    */
extern    pid_t        FsysPid;            
extern    unsigned    MaxIO,
                    io_addr,
                    hw_irq;

/*
    This buffer is defined when the driver is initialed.
*/
extern    struct dma_buffer    iobuffer;    
extern disk_t    disk[MAX_NDRIVES];    /* Disk parameter tables    */

#define    wstr(x,fd)    (write((fd),(x),strlen(x)))

extern long    stack[STACK_SIZE];



#endif
